program pgas_test
implicit none 

integer            :: myrank, numprocs
integer            :: coords(2), coords_plus_1_1(2), coords_minus_1_1(2), codims(2)
real :: x[0:1,0:*]

myrank   = THIS_IMAGE() - 1
numprocs = NUM_IMAGES()
coords   = THIS_IMAGE(x) 
! codims(1)=ucobound(x,1)-lcobound(x,1)+1 
codims(1)= 2
! codims(2)=ucobound(x,2)-lcobound(x,2)+1 
codims(2)= numprocs/codims(1)
! 
! Due to a compiler bug, ucobound and lcobound do not work
! with the Cray Fortran Compiler Version 7.2.2 on Cray XT5m  
! (module PrgEnv-cray/1.0.1) if x is not an array in each image. 
! The substitution of "x" by "x(1)" is a valid work-around
! (to be done in the declaration "real ::", the assignment "x=",
! and all 6 print lines.  
 
! Coordinates of the diagonal neighbor (+1,+1): 
coords_plus_1_1(1) = mod(coords(1)+1,codims(1)) 
coords_plus_1_1(2) = mod(coords(2)+1,codims(2)) 
! Coordinates of the diagonal neighbor (-1,-1): 
coords_minus_1_1(1) = mod(coords(1)-1+codims(1),codims(1)) 
coords_minus_1_1(2) = mod(coords(2)-1+codims(2),codims(2)) 

if (myrank == 0) then
  print *, 'myrank=',myrank, &
         & ' numprocs=',numprocs, &
         & ' =',codims(1),'*',codims(2)
endif
 
x=1000+myrank
!x[(coords(1),coords(2)]=1000+myrank
 
sync all
 
print *, 'myrank=',myrank, &
       & ' c1=',coords(1),' c2=',coords(2), ' (with CAF)', &
       & ' x[',coords_minus_1_1(1),',',coords_minus_1_1(2),']=',&
       &   x[  coords_minus_1_1(1),    coords_minus_1_1(2)  ]  ,&
       & ' x[',coords(1),',',coords(2),']=',&
       &   x[  coords(1),    coords(2)  ]  ,&
       & ' x[',coords_plus_1_1(1),',',coords_plus_1_1(2),']=',&
       &   x[  coords_plus_1_1(1),    coords_plus_1_1(2)  ]

end program pgas_test
