program compute_pi
implicit none 

! times using cpu_time
real t0,t1

integer            :: i
integer, parameter :: n=100000000
real(kind=8), parameter :: pi_ref = 3.1415926535897932384626433_8
real(kind=8)       :: w,x,sum,pi,f,a

call cpu_time(t0)

! calculate pi = integral [0..1] 4/(1+x**2) dx
w=1.0_8/n
sum=0.0_8
do i=1,n
     x=w*(i-0.5_8)
!    function to integrate
     sum=sum + 4.0_8/(1.0_8+x*x)
enddo
pi=w*sum

call cpu_time(t1)

  write (*,'(a,f24.16)')   'computed  pi     = ', pi
  write (*,'(a,f24.16)')   'reference pi_ref = ', pi_ref
  write (*,'(a,f24.16)')   'error= pi-pi_ref = ', pi - pi_ref
  write (*,'(a,f14.6,a)')  'cpu_time:          ', t1-t0, ' sec'

end program compute_pi
